// wmf.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "wmf.h"

/**
 * [ʂB
 */
void CloseDialog(void)
{
	WCHAR text[256];
	HWND hWnd = NULL, hChildWnd = NULL;

	//_CAOTB
	hWnd = FindWindow(_T("Dialog"), NULL);
	if (!hWnd) return;

	//q̃EBhEuWorkervǂׂ
	hChildWnd = GetWindow(hWnd, GW_CHILD);
	if (!hChildWnd) return;
	if (!GetClassName(hChildWnd, text, 256) || wcscmp(text, _T("Worker")) != 0) return;

	//̎qEBhEuPIEHTMLvǂׂ
	hChildWnd = GetWindow(hChildWnd, GW_CHILD);
	if (!hChildWnd) return;
	if (!GetClassName(hChildWnd, text, 256) || wcscmp(text, _T("PIEHTML")) != 0) return;

	//̎qEBhEȂƂ𒲂ׂ
	hChildWnd = GetWindow(hChildWnd, GW_CHILD);
	if (hChildWnd) return;

	//IbZ[W𑗂
	SendMessage(hWnd, WM_CLOSE, 0, 0);
}

/**
 * ǃ[\B
 */
BOOL ShowNoreadMail(MAPI::CFolder &folder)
{
	MAPI::CMessages &messages = folder.GetNoreadMessages();
	BOOL result = (messages.size() > 0);
	if (result) {
		MAPI::CMessage *pMessage = *(messages.begin());
		if (!pMessage->IsRead()) {
			pMessage->SetRead(TRUE);
		}
		pMessage->Display();
	}
	return result;
}

/**
 * [̃c[r[\B
 */
BOOL ShowFolderTreeView(void)
{
	WCHAR text[256];
	HWND hWnd = NULL;

	//[ʂT
	hWnd = FindWindow(_T("Inbox.MainWnd"), NULL);
	if (!hWnd) return FALSE;

	//c[r[T
	hWnd = GetWindow(hWnd, GW_CHILD);
	do {
		if (!hWnd) break;
		if (GetClassName(hWnd, text, 256) && wcscmp(text, _T("ToolbarWindow32")) == 0) break;
		hWnd = GetWindow(hWnd, GW_HWNDNEXT);
	} while (TRUE);
	if (!hWnd) return FALSE;

	int ret = 0;

	//m
	HANDLE hMap = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeof(TBBUTTON), _T("MOMO"));
	if (hMap == NULL) return FALSE;
	LPTBBUTTON lptb = (LPTBBUTTON)MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
	if (lptb != NULL) {
		ZeroMemory(lptb, sizeof(TBBUTTON));
		UnmapViewOfFile(lptb);

		//g
		ret = SendMessage(hWnd, TB_GETBUTTON, 1, (LPARAM)lptb);
		if (ret) {
			ret = SendMessage(hWnd, WM_COMMAND, (WPARAM)MAKELONG(lptb->idCommand, 0), NULL);
		}
	}
	CloseHandle(hMap);

	return TRUE;
}

/**
 * [\B
 */
void ShowMailer(MAPI::CSession &Session, CIniFile &ini, BOOL ShowNoReadMailFlag)
{
	//PDX̎Mς݃ACe擾
	MAPI::CFolder &folder = Session.GetFolder(ini.GetValue(_T("setting"), _T("openfolder")));
	if (folder.GetAllMessageCount() == 0) {
		if (ini.GetIntValue(_T("setting"), _T("openlastfilterfolder")) && g_LastFilterFolder.size() > 0) {
			folder = Session.GetFolder(g_LastFilterFolder);
		} else {
			folder = Session.GetFolder(ini.GetValue(_T("setting"), _T("openfolderwhenempty")));
		}
	}

	//ǃ[ΊǂɂĂ\
	BOOL IsShowMail = (ShowNoReadMailFlag && ShowNoreadMail(folder));

	//tH_\
	folder.MailSwitchToFolder();

	//c[r[\
	if (!IsShowMail && ini.GetIntValue(_T("setting"), _T("showdir"))) {
		ShowFolderTreeView();
	}
}

#define MUTEX_GUID _T("{BCBD5D01-E685-442c-ABBD-D02104F4ED29}")
BOOL ExistInstance(HINSTANCE hInstance)
{
	CreateMutex(NULL, TRUE, MUTEX_GUID);
	return (GetLastError() == ERROR_ALREADY_EXISTS);
}


int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	//dN`FbN
	if (ExistInstance(hInstance)) {
		return 1;
	}

	HCURSOR hWaitCursor = NULL, hOldCursor = NULL;
	try {
		if (hWaitCursor = LoadCursor(NULL, IDC_WAIT)) {
			hOldCursor = SetCursor(hWaitCursor);
		}

		MAPI::CMAPI mapi;
		MAPI::CSession Session;

		//ݒǂݍ
		CIniFile ini(hInstance);
		SetDefaultIniData(ini, Session);

		//U蕪ݒ
		Strings folders = SetFilterSetting(Session, ini);

		//ݒۑ
		ini.Save();

		//ɊJĂ_CAOB
		CloseDialog();

		//U蕪
		FilterMail(Session, ini, folders);

		//[\
		int ShowNoReadMailFlag = ini.GetIntValue(_T("setting"), _T("shownoread"));
		ShowMailer(Session, ini, ShowNoReadMailFlag);

	} catch (wchar_t *ex) {
		MessageBox(GetForegroundWindow(), ex, _T("Error"), MB_OK);
	}

	if (!hOldCursor) {
		SetCursor(hOldCursor);
	}

	return 0;
}
